org.apache.fop.afp.modca

## Class AbstractEnvironmentGroup

- java.lang.Object
- - org.apache.fop.afp.modca.AbstractAFPObject
  - - org.apache.fop.afp.modca.AbstractStructuredObject
    - - org.apache.fop.afp.modca.AbstractTripletStructuredObject
      - - org.apache.fop.afp.modca.AbstractNamedAFPObject
        - - org.apache.fop.afp.modca.AbstractEnvironmentGroup

All Implemented Interfaces:
  Streamable

Direct Known Subclasses:
  ActiveEnvironmentGroup, ResourceEnvironmentGroup

    public abstract class AbstractEnvironmentGroup
    extends AbstractNamedAFPObject

A base class that encapsulates common features of ActiveEnvironmentGroup and ResourceEnvironmentGroup

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.fop.afp.modca.AbstractAFPObject

`AbstractAFPObject.Category, AbstractAFPObject.Type`

### Field Summary

Fields
`protected List` `mapDataResources` the collection of MapDataResource objects
`protected List` `mapPageOverlays` the collection of MapPageOverlay objects

### Fields inherited from class org.apache.fop.afp.modca.AbstractNamedAFPObject

`name`

### Fields inherited from class org.apache.fop.afp.modca.AbstractTripletStructuredObject

`triplets`

### Fields inherited from class org.apache.fop.afp.modca.AbstractAFPObject

`LOG, SF_CLASS, SF_HEADER_LENGTH`

### Constructor Summary

Constructors
Constructor and Description
`AbstractEnvironmentGroup(String name)` Main constructor

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `createOverlay(String name)` Actually creates the MPO object.
`protected Object` `getLastElement(List list)` Get last element.
`protected void` `writeContent(OutputStream os)` Helper method to write the contents of the Object.

### Methods inherited from class org.apache.fop.afp.modca.AbstractNamedAFPObject

`copySF, getName, getNameBytes, getNameLength, setName, toString`

### Methods inherited from class org.apache.fop.afp.modca.AbstractTripletStructuredObject

`addTriplet, addTriplets, getFullyQualifiedName, getTripletDataLength, getTriplets, hasTriplet, hasTriplets, setComment, setFullyQualifiedName, setFullyQualifiedName, setObjectClassification, writeTriplets`

### Methods inherited from class org.apache.fop.afp.modca.AbstractStructuredObject

`writeEnd, writeStart, writeToStream`

### Methods inherited from class org.apache.fop.afp.modca.AbstractAFPObject

`copySF, truncate, writeChunksToStream, writeObjects`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### mapDataResources

    protected final List mapDataResources

the collection of MapDataResource objects

#### mapPageOverlays

    protected List mapPageOverlays

the collection of MapPageOverlay objects

### Constructor Detail

#### AbstractEnvironmentGroup

    public AbstractEnvironmentGroup(String name)

Main constructor

Parameters:
  `name` - the object name

### Method Detail

#### createOverlay

    public void createOverlay(String name)

Actually creates the MPO object. Also creates the supporting object (an IPO)

Parameters:
  `name` - the name of the overlay to be used

#### getLastElement

    protected Object getLastElement(List list)

Get last element.

Parameters:
  `list` - of elements
Returns:
  last element or null if none

#### writeContent

    protected void writeContent(OutputStream os)
                         throws IOException

Helper method to write the contents of the Object.

Overrides:
  `writeContent` in class `AbstractStructuredObject`
Parameters:
  `os` - The stream to write to
Throws:
  `IOException` - throws an I/O exception if one occurred